diff -Naur linux-source-2.6.38.orig/kernel/process.c linux-source-2.6.38.modif/kernel/process.c
--- linux-source-2.6.38.orig/kernel/process.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/process.c	2011-12-16 12:29:19.000000000 +0100
@@ -0,0 +1,705 @@
+#include <linux/errno.h>
+#include <linux/kernel.h>
+#include <linux/mm.h>
+#include <linux/smp.h>
+#include <linux/prctl.h>
+#include <linux/slab.h>
+#include <linux/sched.h>
+#include <linux/module.h>
+#include <linux/pm.h>
+#include <linux/clockchips.h>
+#include <linux/random.h>
+#include <linux/user-return-notifier.h>
+#include <linux/dmi.h>
+#include <linux/utsname.h>
+#include <trace/events/power.h>
+#include <linux/hw_breakpoint.h>
+#include <asm/cpu.h>
+#include <asm/system.h>
+#include <asm/apic.h>
+#include <asm/syscalls.h>
+#include <asm/idle.h>
+#include <asm/uaccess.h>
+#include <asm/i387.h>
+#include <asm/debugreg.h>
+
+struct kmem_cache *task_xstate_cachep;
+EXPORT_SYMBOL_GPL(task_xstate_cachep);
+
+int arch_dup_task_struct(struct task_struct *dst, struct task_struct *src)
+{
+	int ret;
+
+	*dst = *src;
+	if (fpu_allocated(&src->thread.fpu)) {
+		memset(&dst->thread.fpu, 0, sizeof(dst->thread.fpu));
+		ret = fpu_alloc(&dst->thread.fpu);
+		if (ret)
+			return ret;
+		fpu_copy(&dst->thread.fpu, &src->thread.fpu);
+	}
+	return 0;
+}
+
+void free_thread_xstate(struct task_struct *tsk)
+{
+	fpu_free(&tsk->thread.fpu);
+}
+
+void free_thread_info(struct thread_info *ti)
+{
+	free_thread_xstate(ti->task);
+	free_pages((unsigned long)ti, get_order(THREAD_SIZE));
+}
+
+void arch_task_cache_init(void)
+{
+        task_xstate_cachep =
+        	kmem_cache_create("task_xstate", xstate_size,
+				  __alignof__(union thread_xstate),
+				  SLAB_PANIC | SLAB_NOTRACK, NULL);
+}
+
+/*
+ * Free current thread data structures etc..
+ */
+void exit_thread(void)
+{
+	struct task_struct *me = current;
+	struct thread_struct *t = &me->thread;
+	unsigned long *bp = t->io_bitmap_ptr;
+
+	if (bp) {
+		struct tss_struct *tss = &per_cpu(init_tss, get_cpu());
+
+		t->io_bitmap_ptr = NULL;
+		clear_thread_flag(TIF_IO_BITMAP);
+		/*
+		 * Careful, clear this in the TSS too:
+		 */
+		memset(tss->io_bitmap, 0xff, t->io_bitmap_max);
+		t->io_bitmap_max = 0;
+		put_cpu();
+		kfree(bp);
+	}
+}
+
+void show_regs(struct pt_regs *regs)
+{
+	show_registers(regs);
+	show_trace(NULL, regs, (unsigned long *)kernel_stack_pointer(regs));
+}
+
+void show_regs_common(void)
+{
+	const char *vendor, *product, *board;
+
+	vendor = dmi_get_system_info(DMI_SYS_VENDOR);
+	if (!vendor)
+		vendor = "";
+	product = dmi_get_system_info(DMI_PRODUCT_NAME);
+	if (!product)
+		product = "";
+
+	/* Board Name is optional */
+	board = dmi_get_system_info(DMI_BOARD_NAME);
+
+	printk(KERN_CONT "\n");
+	printk(KERN_DEFAULT "Pid: %d, comm: %.20s %s %s %.*s",
+		current->pid, current->comm, print_tainted(),
+		init_utsname()->release,
+		(int)strcspn(init_utsname()->version, " "),
+		init_utsname()->version);
+	printk(KERN_CONT " ");
+	printk(KERN_CONT "%s %s", vendor, product);
+	if (board) {
+		printk(KERN_CONT "/");
+		printk(KERN_CONT "%s", board);
+	}
+	printk(KERN_CONT "\n");
+}
+
+void flush_thread(void)
+{
+	struct task_struct *tsk = current;
+
+	flush_ptrace_hw_breakpoint(tsk);
+	memset(tsk->thread.tls_array, 0, sizeof(tsk->thread.tls_array));
+	/*
+	 * Forget coprocessor state..
+	 */
+	tsk->fpu_counter = 0;
+	clear_fpu(tsk);
+	clear_used_math();
+}
+
+static void hard_disable_TSC(void)
+{
+	write_cr4(read_cr4() | X86_CR4_TSD);
+}
+
+void disable_TSC(void)
+{
+	preempt_disable();
+	if (!test_and_set_thread_flag(TIF_NOTSC))
+		/*
+		 * Must flip the CPU state synchronously with
+		 * TIF_NOTSC in the current running context.
+		 */
+		hard_disable_TSC();
+	preempt_enable();
+}
+
+static void hard_enable_TSC(void)
+{
+	write_cr4(read_cr4() & ~X86_CR4_TSD);
+}
+
+static void enable_TSC(void)
+{
+	preempt_disable();
+	if (test_and_clear_thread_flag(TIF_NOTSC))
+		/*
+		 * Must flip the CPU state synchronously with
+		 * TIF_NOTSC in the current running context.
+		 */
+		hard_enable_TSC();
+	preempt_enable();
+}
+
+int get_tsc_mode(unsigned long adr)
+{
+	unsigned int val;
+
+	if (test_thread_flag(TIF_NOTSC))
+		val = PR_TSC_SIGSEGV;
+	else
+		val = PR_TSC_ENABLE;
+
+	return put_user(val, (unsigned int __user *)adr);
+}
+
+int set_tsc_mode(unsigned int val)
+{
+	if (val == PR_TSC_SIGSEGV)
+		disable_TSC();
+	else if (val == PR_TSC_ENABLE)
+		enable_TSC();
+	else
+		return -EINVAL;
+
+	return 0;
+}
+
+void __switch_to_xtra(struct task_struct *prev_p, struct task_struct *next_p,
+		      struct tss_struct *tss)
+{
+	struct thread_struct *prev, *next;
+
+	prev = &prev_p->thread;
+	next = &next_p->thread;
+
+	if (test_tsk_thread_flag(prev_p, TIF_BLOCKSTEP) ^
+	    test_tsk_thread_flag(next_p, TIF_BLOCKSTEP)) {
+		unsigned long debugctl = get_debugctlmsr();
+
+		debugctl &= ~DEBUGCTLMSR_BTF;
+		if (test_tsk_thread_flag(next_p, TIF_BLOCKSTEP))
+			debugctl |= DEBUGCTLMSR_BTF;
+
+		update_debugctlmsr(debugctl);
+	}
+
+	if (test_tsk_thread_flag(prev_p, TIF_NOTSC) ^
+	    test_tsk_thread_flag(next_p, TIF_NOTSC)) {
+		/* prev and next are different */
+		if (test_tsk_thread_flag(next_p, TIF_NOTSC))
+			hard_disable_TSC();
+		else
+			hard_enable_TSC();
+	}
+
+	if (test_tsk_thread_flag(next_p, TIF_IO_BITMAP)) {
+		/*
+		 * Copy the relevant range of the IO bitmap.
+		 * Normally this is 128 bytes or less:
+		 */
+		memcpy(tss->io_bitmap, next->io_bitmap_ptr,
+		       max(prev->io_bitmap_max, next->io_bitmap_max));
+	} else if (test_tsk_thread_flag(prev_p, TIF_IO_BITMAP)) {
+		/*
+		 * Clear any possible leftover bits:
+		 */
+		memset(tss->io_bitmap, 0xff, prev->io_bitmap_max);
+	}
+	propagate_user_return_notify(prev_p, next_p);
+}
+
+int sys_fork(struct pt_regs *regs)
+{
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|fork");
+
+	return do_fork(SIGCHLD, regs->sp, regs, 0, NULL, NULL);
+}
+
+/*
+ * This is trivial, and on the face of it looks like it
+ * could equally well be done in user mode.
+ *
+ * Not so, for quite unobvious reasons - register pressure.
+ * In user mode vfork() cannot have a stack frame, and if
+ * done by calling the "clone()" system call directly, you
+ * do not have enough call-clobbered registers to hold all
+ * the information you need.
+ */
+int sys_vfork(struct pt_regs *regs)
+{
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|vfork");
+
+	return do_fork(CLONE_VFORK | CLONE_VM | SIGCHLD, regs->sp, regs, 0,
+		       NULL, NULL);
+}
+
+long
+sys_clone(unsigned long clone_flags, unsigned long newsp,
+	  void __user *parent_tid, void __user *child_tid, struct pt_regs *regs)
+{
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|clone");
+
+	if (!newsp)
+		newsp = regs->sp;
+	return do_fork(clone_flags, newsp, regs, 0, parent_tid, child_tid);
+}
+
+/*
+ * This gets run with %si containing the
+ * function to call, and %di containing
+ * the "args".
+ */
+extern void kernel_thread_helper(void);
+
+/*
+ * Create a kernel thread
+ */
+int kernel_thread(int (*fn)(void *), void *arg, unsigned long flags)
+{
+	struct pt_regs regs;
+
+	memset(&regs, 0, sizeof(regs));
+
+	regs.si = (unsigned long) fn;
+	regs.di = (unsigned long) arg;
+
+#ifdef CONFIG_X86_32
+	regs.ds = __USER_DS;
+	regs.es = __USER_DS;
+	regs.fs = __KERNEL_PERCPU;
+	regs.gs = __KERNEL_STACK_CANARY;
+#else
+	regs.ss = __KERNEL_DS;
+#endif
+
+	regs.orig_ax = -1;
+	regs.ip = (unsigned long) kernel_thread_helper;
+	regs.cs = __KERNEL_CS | get_kernel_rpl();
+	regs.flags = X86_EFLAGS_IF | 0x2;
+
+	/* Ok, create the new process.. */
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+}
+EXPORT_SYMBOL(kernel_thread);
+
+/*
+ * sys_execve() executes a new program.
+ */
+long sys_execve(const char __user *name,
+		const char __user *const __user *argv,
+		const char __user *const __user *envp, struct pt_regs *regs)
+{
+	long error;
+	char *filename;
+
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|execve");
+
+	filename = getname(name);
+	error = PTR_ERR(filename);
+	if (IS_ERR(filename))
+		return error;
+	error = do_execve(filename, argv, envp, regs);
+
+#ifdef CONFIG_X86_32
+	if (error == 0) {
+		/* Make sure we don't return using sysenter.. */
+                set_thread_flag(TIF_IRET);
+        }
+#endif
+
+	putname(filename);
+	return error;
+}
+
+/*
+ * Idle related variables and functions
+ */
+unsigned long boot_option_idle_override = IDLE_NO_OVERRIDE;
+EXPORT_SYMBOL(boot_option_idle_override);
+
+/*
+ * Powermanagement idle function, if any..
+ */
+void (*pm_idle)(void);
+EXPORT_SYMBOL(pm_idle);
+
+#ifdef CONFIG_X86_32
+/*
+ * This halt magic was a workaround for ancient floppy DMA
+ * wreckage. It should be safe to remove.
+ */
+static int hlt_counter;
+void disable_hlt(void)
+{
+	hlt_counter++;
+}
+EXPORT_SYMBOL(disable_hlt);
+
+void enable_hlt(void)
+{
+	hlt_counter--;
+}
+EXPORT_SYMBOL(enable_hlt);
+
+static inline int hlt_use_halt(void)
+{
+	return (!hlt_counter && boot_cpu_data.hlt_works_ok);
+}
+#else
+static inline int hlt_use_halt(void)
+{
+	return 1;
+}
+#endif
+
+/*
+ * We use this if we don't have any better
+ * idle routine..
+ */
+void default_idle(void)
+{
+	if (hlt_use_halt()) {
+		trace_power_start(POWER_CSTATE, 1, smp_processor_id());
+		trace_cpu_idle(1, smp_processor_id());
+		current_thread_info()->status &= ~TS_POLLING;
+		/*
+		 * TS_POLLING-cleared state must be visible before we
+		 * test NEED_RESCHED:
+		 */
+		smp_mb();
+
+		if (!need_resched())
+			safe_halt();	/* enables interrupts racelessly */
+		else
+			local_irq_enable();
+		current_thread_info()->status |= TS_POLLING;
+		trace_power_end(smp_processor_id());
+		trace_cpu_idle(PWR_EVENT_EXIT, smp_processor_id());
+	} else {
+		local_irq_enable();
+		/* loop is done by the caller */
+		cpu_relax();
+	}
+}
+#ifdef CONFIG_APM_MODULE
+EXPORT_SYMBOL(default_idle);
+#endif
+
+void stop_this_cpu(void *dummy)
+{
+	local_irq_disable();
+	/*
+	 * Remove this CPU:
+	 */
+	set_cpu_online(smp_processor_id(), false);
+	disable_local_APIC();
+
+	for (;;) {
+		if (hlt_works(smp_processor_id()))
+			halt();
+	}
+}
+
+static void do_nothing(void *unused)
+{
+}
+
+/*
+ * cpu_idle_wait - Used to ensure that all the CPUs discard old value of
+ * pm_idle and update to new pm_idle value. Required while changing pm_idle
+ * handler on SMP systems.
+ *
+ * Caller must have changed pm_idle to the new value before the call. Old
+ * pm_idle value will not be used by any CPU after the return of this function.
+ */
+void cpu_idle_wait(void)
+{
+	smp_mb();
+	/* kick all the CPUs so that they exit out of pm_idle */
+	smp_call_function(do_nothing, NULL, 1);
+}
+EXPORT_SYMBOL_GPL(cpu_idle_wait);
+
+/*
+ * This uses new MONITOR/MWAIT instructions on P4 processors with PNI,
+ * which can obviate IPI to trigger checking of need_resched.
+ * We execute MONITOR against need_resched and enter optimized wait state
+ * through MWAIT. Whenever someone changes need_resched, we would be woken
+ * up from MWAIT (without an IPI).
+ *
+ * New with Core Duo processors, MWAIT can take some hints based on CPU
+ * capability.
+ */
+void mwait_idle_with_hints(unsigned long ax, unsigned long cx)
+{
+	if (!need_resched()) {
+		if (cpu_has(__this_cpu_ptr(&cpu_info), X86_FEATURE_CLFLUSH_MONITOR))
+			clflush((void *)&current_thread_info()->flags);
+
+		__monitor((void *)&current_thread_info()->flags, 0, 0);
+		smp_mb();
+		if (!need_resched())
+			__mwait(ax, cx);
+	}
+}
+
+/* Default MONITOR/MWAIT with no hints, used for default C1 state */
+static void mwait_idle(void)
+{
+	if (!need_resched()) {
+		trace_power_start(POWER_CSTATE, 1, smp_processor_id());
+		trace_cpu_idle(1, smp_processor_id());
+		if (cpu_has(__this_cpu_ptr(&cpu_info), X86_FEATURE_CLFLUSH_MONITOR))
+			clflush((void *)&current_thread_info()->flags);
+
+		__monitor((void *)&current_thread_info()->flags, 0, 0);
+		smp_mb();
+		if (!need_resched())
+			__sti_mwait(0, 0);
+		else
+			local_irq_enable();
+		trace_power_end(smp_processor_id());
+		trace_cpu_idle(PWR_EVENT_EXIT, smp_processor_id());
+	} else
+		local_irq_enable();
+}
+
+/*
+ * On SMP it's slightly faster (but much more power-consuming!)
+ * to poll the ->work.need_resched flag instead of waiting for the
+ * cross-CPU IPI to arrive. Use this option with caution.
+ */
+static void poll_idle(void)
+{
+	trace_power_start(POWER_CSTATE, 0, smp_processor_id());
+	trace_cpu_idle(0, smp_processor_id());
+	local_irq_enable();
+	while (!need_resched())
+		cpu_relax();
+	trace_power_end(smp_processor_id());
+	trace_cpu_idle(PWR_EVENT_EXIT, smp_processor_id());
+}
+
+/*
+ * mwait selection logic:
+ *
+ * It depends on the CPU. For AMD CPUs that support MWAIT this is
+ * wrong. Family 0x10 and 0x11 CPUs will enter C1 on HLT. Powersavings
+ * then depend on a clock divisor and current Pstate of the core. If
+ * all cores of a processor are in halt state (C1) the processor can
+ * enter the C1E (C1 enhanced) state. If mwait is used this will never
+ * happen.
+ *
+ * idle=mwait overrides this decision and forces the usage of mwait.
+ */
+
+#define MWAIT_INFO			0x05
+#define MWAIT_ECX_EXTENDED_INFO		0x01
+#define MWAIT_EDX_C1			0xf0
+
+int mwait_usable(const struct cpuinfo_x86 *c)
+{
+	u32 eax, ebx, ecx, edx;
+
+	if (boot_option_idle_override == IDLE_FORCE_MWAIT)
+		return 1;
+
+	if (c->cpuid_level < MWAIT_INFO)
+		return 0;
+
+	cpuid(MWAIT_INFO, &eax, &ebx, &ecx, &edx);
+	/* Check, whether EDX has extended info about MWAIT */
+	if (!(ecx & MWAIT_ECX_EXTENDED_INFO))
+		return 1;
+
+	/*
+	 * edx enumeratios MONITOR/MWAIT extensions. Check, whether
+	 * C1  supports MWAIT
+	 */
+	return (edx & MWAIT_EDX_C1);
+}
+
+bool c1e_detected;
+EXPORT_SYMBOL(c1e_detected);
+
+static cpumask_var_t c1e_mask;
+
+void c1e_remove_cpu(int cpu)
+{
+	if (c1e_mask != NULL)
+		cpumask_clear_cpu(cpu, c1e_mask);
+}
+
+/*
+ * C1E aware idle routine. We check for C1E active in the interrupt
+ * pending message MSR. If we detect C1E, then we handle it the same
+ * way as C3 power states (local apic timer and TSC stop)
+ */
+static void c1e_idle(void)
+{
+	if (need_resched())
+		return;
+
+	if (!c1e_detected) {
+		u32 lo, hi;
+
+		rdmsr(MSR_K8_INT_PENDING_MSG, lo, hi);
+
+		if (lo & K8_INTP_C1E_ACTIVE_MASK) {
+			c1e_detected = true;
+			if (!boot_cpu_has(X86_FEATURE_NONSTOP_TSC))
+				mark_tsc_unstable("TSC halt in AMD C1E");
+			printk(KERN_INFO "System has AMD C1E enabled\n");
+		}
+	}
+
+	if (c1e_detected) {
+		int cpu = smp_processor_id();
+
+		if (!cpumask_test_cpu(cpu, c1e_mask)) {
+			cpumask_set_cpu(cpu, c1e_mask);
+			/*
+			 * Force broadcast so ACPI can not interfere.
+			 */
+			clockevents_notify(CLOCK_EVT_NOTIFY_BROADCAST_FORCE,
+					   &cpu);
+			printk(KERN_INFO "Switch to broadcast mode on CPU%d\n",
+			       cpu);
+		}
+		clockevents_notify(CLOCK_EVT_NOTIFY_BROADCAST_ENTER, &cpu);
+
+		default_idle();
+
+		/*
+		 * The switch back from broadcast mode needs to be
+		 * called with interrupts disabled.
+		 */
+		 local_irq_disable();
+		 clockevents_notify(CLOCK_EVT_NOTIFY_BROADCAST_EXIT, &cpu);
+		 local_irq_enable();
+	} else
+		default_idle();
+}
+
+void __cpuinit select_idle_routine(const struct cpuinfo_x86 *c)
+{
+#ifdef CONFIG_SMP
+	if (pm_idle == poll_idle && smp_num_siblings > 1) {
+		printk_once(KERN_WARNING "WARNING: polling idle and HT enabled,"
+			" performance may degrade.\n");
+	}
+#endif
+	if (pm_idle)
+		return;
+
+	if (cpu_has(c, X86_FEATURE_MWAIT) && mwait_usable(c)) {
+		/*
+		 * One CPU supports mwait => All CPUs supports mwait
+		 */
+		printk(KERN_INFO "using mwait in idle threads.\n");
+		pm_idle = mwait_idle;
+	} else if (cpu_has_amd_erratum(amd_erratum_400)) {
+		/* E400: APIC timer interrupt does not wake up CPU from C1e */
+		printk(KERN_INFO "using C1E aware idle routine\n");
+		pm_idle = c1e_idle;
+	} else
+		pm_idle = default_idle;
+}
+
+void __init init_c1e_mask(void)
+{
+	/* If we're using c1e_idle, we need to allocate c1e_mask. */
+	if (pm_idle == c1e_idle)
+		zalloc_cpumask_var(&c1e_mask, GFP_KERNEL);
+}
+
+static int __init idle_setup(char *str)
+{
+	if (!str)
+		return -EINVAL;
+
+	if (!strcmp(str, "poll")) {
+		printk("using polling idle threads.\n");
+		pm_idle = poll_idle;
+		boot_option_idle_override = IDLE_POLL;
+	} else if (!strcmp(str, "mwait")) {
+		boot_option_idle_override = IDLE_FORCE_MWAIT;
+	} else if (!strcmp(str, "halt")) {
+		/*
+		 * When the boot option of idle=halt is added, halt is
+		 * forced to be used for CPU idle. In such case CPU C2/C3
+		 * won't be used again.
+		 * To continue to load the CPU idle driver, don't touch
+		 * the boot_option_idle_override.
+		 */
+		pm_idle = default_idle;
+		boot_option_idle_override = IDLE_HALT;
+	} else if (!strcmp(str, "nomwait")) {
+		/*
+		 * If the boot option of "idle=nomwait" is added,
+		 * it means that mwait will be disabled for CPU C2/C3
+		 * states. In such case it won't touch the variable
+		 * of boot_option_idle_override.
+		 */
+		boot_option_idle_override = IDLE_NOMWAIT;
+	} else
+		return -1;
+
+	return 0;
+}
+early_param("idle", idle_setup);
+
+unsigned long arch_align_stack(unsigned long sp)
+{
+	if (!(current->personality & ADDR_NO_RANDOMIZE) && randomize_va_space)
+		sp -= get_random_int() % 8192;
+	return sp & ~0xf;
+}
+
+unsigned long arch_randomize_brk(struct mm_struct *mm)
+{
+	unsigned long range_end = mm->brk + 0x02000000;
+	unsigned long bump = 0;
+#ifdef CONFIG_X86_32
+	/* in the case of NX emulation, shove the brk segment way out of the
+	   way of the exec randomization area, since it can collide with
+	   future allocations if not. */
+	if ( (mm->get_unmapped_exec_area == arch_get_unmapped_exec_area) &&
+	     (mm->brk < 0x08000000) ) {
+		bump = (TASK_SIZE/6);
+	}
+#endif
+	return bump + (randomize_range(mm->brk, range_end, 0) ? : mm->brk);
+}
+
diff -Naur linux-source-2.6.38.orig/kernel/ptrace.c linux-source-2.6.38.modif/kernel/ptrace.c
--- linux-source-2.6.38.orig/kernel/ptrace.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/ptrace.c	2011-12-16 15:58:34.000000000 +0100
@@ -701,6 +701,9 @@
 	struct task_struct *child;
 	long ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|ptrace");
+
 	if (request == PTRACE_TRACEME) {
 		ret = ptrace_traceme();
 		if (!ret)
diff -Naur linux-source-2.6.38.orig/kernel/sched.c linux-source-2.6.38.modif/kernel/sched.c
--- linux-source-2.6.38.orig/kernel/sched.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/sched.c	2011-12-16 14:28:52.000000000 +0100
@@ -4655,6 +4655,9 @@
 {
 	long nice, retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|nice");
+
 	/*
 	 * Setpriority might change our priority at the same moment.
 	 * We don't have to worry. Conceptually one call occurs first
@@ -4979,6 +4982,9 @@
 SYSCALL_DEFINE3(sched_setscheduler, pid_t, pid, int, policy,
 		struct sched_param __user *, param)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_setscheduler");
+
 	/* negative values for policy are not valid */
 	if (policy < 0)
 		return -EINVAL;
@@ -4993,6 +4999,9 @@
  */
 SYSCALL_DEFINE2(sched_setparam, pid_t, pid, struct sched_param __user *, param)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_setparam");
+
 	return do_sched_setscheduler(pid, -1, param);
 }
 
@@ -5005,6 +5014,9 @@
 	struct task_struct *p;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_getscheduler");
+
 	if (pid < 0)
 		return -EINVAL;
 
@@ -5032,6 +5044,9 @@
 	struct task_struct *p;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_getparam");
+
 	if (!param || pid < 0)
 		return -EINVAL;
 
@@ -5146,6 +5161,9 @@
 	cpumask_var_t new_mask;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_setaffinity");
+
 	if (!alloc_cpumask_var(&new_mask, GFP_KERNEL))
 		return -ENOMEM;
 
@@ -5198,6 +5216,9 @@
 	int ret;
 	cpumask_var_t mask;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_getaffinity");
+
 	if ((len * BITS_PER_BYTE) < nr_cpu_ids)
 		return -EINVAL;
 	if (len & (sizeof(unsigned long)-1))
@@ -5230,6 +5251,9 @@
 {
 	struct rq *rq = this_rq_lock();
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_yield");
+
 	schedstat_inc(rq, yld_count);
 	current->sched_class->yield_task(rq);
 
@@ -5368,6 +5392,9 @@
 {
 	int ret = -EINVAL;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_get_priority_max");
+
 	switch (policy) {
 	case SCHED_FIFO:
 	case SCHED_RR:
@@ -5393,6 +5420,9 @@
 {
 	int ret = -EINVAL;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_get_priority_min");
+
 	switch (policy) {
 	case SCHED_FIFO:
 	case SCHED_RR:
@@ -5424,6 +5454,9 @@
 	int retval;
 	struct timespec t;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sched_rr_get_interval");
+
 	if (pid < 0)
 		return -EINVAL;
 
diff -Naur linux-source-2.6.38.orig/kernel/signal.c linux-source-2.6.38.modif/kernel/signal.c
--- linux-source-2.6.38.orig/kernel/signal.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/signal.c	2011-12-16 16:43:52.000000000 +0100
@@ -2117,6 +2117,9 @@
 	int error = -EINVAL;
 	sigset_t old_set, new_set;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_sigprocmask");
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2173,6 +2176,9 @@
 
 SYSCALL_DEFINE2(rt_sigpending, sigset_t __user *, set, size_t, sigsetsize)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_sigpending");
+
 	return do_sigpending(set, sigsetsize);
 }
 
@@ -2260,6 +2266,9 @@
 	siginfo_t info;
 	long timeout = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_sigtimedwait");
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2329,6 +2338,9 @@
 {
 	struct siginfo info;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|kill");
+
 	info.si_signo = sig;
 	info.si_errno = 0;
 	info.si_code = SI_USER;
@@ -2393,6 +2405,9 @@
  */
 SYSCALL_DEFINE3(tgkill, pid_t, tgid, pid_t, pid, int, sig)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|tgkill");
+
 	/* This is only valid for single tasks */
 	if (pid <= 0 || tgid <= 0)
 		return -EINVAL;
@@ -2405,6 +2420,9 @@
  */
 SYSCALL_DEFINE2(tkill, pid_t, pid, int, sig)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|tkill");
+
 	/* This is only valid for single tasks */
 	if (pid <= 0)
 		return -EINVAL;
@@ -2415,6 +2433,9 @@
 SYSCALL_DEFINE3(rt_sigqueueinfo, pid_t, pid, int, sig,
 		siginfo_t __user *, uinfo)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_sigqueueinfo");
+
 	siginfo_t info;
 
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
@@ -2456,6 +2477,9 @@
 SYSCALL_DEFINE4(rt_tgsigqueueinfo, pid_t, tgid, pid_t, pid, int, sig,
 		siginfo_t __user *, uinfo)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_tgsigqueueinfo");
+
 	siginfo_t info;
 
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
@@ -2580,6 +2604,9 @@
 
 SYSCALL_DEFINE1(sigpending, old_sigset_t __user *, set)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sigpending");
+
 	return do_sigpending(set, sizeof(*set));
 }
 
@@ -2595,6 +2622,9 @@
 	int error;
 	old_sigset_t old_set, new_set;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sigprocmask");
+
 	if (set) {
 		error = -EFAULT;
 		if (copy_from_user(&new_set, set, sizeof(*set)))
@@ -2648,6 +2678,9 @@
 	struct k_sigaction new_sa, old_sa;
 	int ret = -EINVAL;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|rt_sigaction");
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2675,6 +2708,9 @@
  */
 SYSCALL_DEFINE0(sgetmask)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sgetmask");
+
 	/* SMP safe */
 	return current->blocked.sig[0];
 }
@@ -2683,6 +2719,9 @@
 {
 	int old;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|ssetmask");
+
 	spin_lock_irq(&current->sighand->siglock);
 	old = current->blocked.sig[0];
 
@@ -2704,6 +2743,9 @@
 	struct k_sigaction new_sa, old_sa;
 	int ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sys_signal");
+
 	new_sa.sa.sa_handler = handler;
 	new_sa.sa.sa_flags = SA_ONESHOT | SA_NOMASK;
 	sigemptyset(&new_sa.sa.sa_mask);
diff -Naur linux-source-2.6.38.orig/kernel/sys.c linux-source-2.6.38.modif/kernel/sys.c
--- linux-source-2.6.38.orig/kernel/sys.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/sys.c	2011-12-16 15:43:54.000000000 +0100
@@ -156,6 +156,9 @@
 	int error = -EINVAL;
 	struct pid *pgrp;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setpriority");
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		goto out;
 
@@ -223,6 +226,9 @@
 	long niceval, retval = -ESRCH;
 	struct pid *pgrp;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getpriority");
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		return -EINVAL;
 
@@ -377,6 +383,9 @@
 	char buffer[256];
 	int ret = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|reboot");
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -493,6 +502,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setregid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -540,6 +552,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setgid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -603,6 +618,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setreuid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -664,6 +682,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setuid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -705,6 +726,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setresuid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -754,6 +778,9 @@
 	const struct cred *cred = current_cred();
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getresuid");
+
 	if (!(retval   = put_user(cred->uid,  ruid)) &&
 	    !(retval   = put_user(cred->euid, euid)))
 		retval = put_user(cred->suid, suid);
@@ -770,6 +797,9 @@
 	struct cred *new;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setresgid");
+
 	new = prepare_creds();
 	if (!new)
 		return -ENOMEM;
@@ -808,6 +838,9 @@
 	const struct cred *cred = current_cred();
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getresgid");
+
 	if (!(retval   = put_user(cred->gid,  rgid)) &&
 	    !(retval   = put_user(cred->egid, egid)))
 		retval = put_user(cred->sgid, sgid);
@@ -828,6 +861,9 @@
 	struct cred *new;
 	uid_t old_fsuid;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setfsuid");
+
 	new = prepare_creds();
 	if (!new)
 		return current_fsuid();
@@ -861,6 +897,9 @@
 	struct cred *new;
 	gid_t old_fsgid;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setfsgid");
+
 	new = prepare_creds();
 	if (!new)
 		return current_fsgid();
@@ -901,6 +940,9 @@
 
 SYSCALL_DEFINE1(times, struct tms __user *, tbuf)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|times");
+
 	if (tbuf) {
 		struct tms tmp;
 
@@ -931,6 +973,9 @@
 	struct pid *pgrp;
 	int err;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setpgid");
+
 	if (!pid)
 		pid = task_pid_vnr(group_leader);
 	if (!pgid)
@@ -1001,6 +1046,9 @@
 	struct pid *grp;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getpgid");
+
 	rcu_read_lock();
 	if (!pid)
 		grp = task_pgrp(current);
@@ -1027,6 +1075,9 @@
 
 SYSCALL_DEFINE0(getpgrp)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getpgrp");
+
 	return sys_getpgid(0);
 }
 
@@ -1038,6 +1089,9 @@
 	struct pid *sid;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sys_getsid");
+
 	rcu_read_lock();
 	if (!pid)
 		sid = task_session(current);
@@ -1067,6 +1121,9 @@
 	pid_t session = pid_vnr(sid);
 	int err = -EPERM;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setsid");
+
 	write_lock_irq(&tasklist_lock);
 	/* Fail if I am already a session leader */
 	if (group_leader->signal->leader)
@@ -1126,6 +1183,9 @@
 {
 	int error = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|uname");
+
 	if (!name)
 		return -EFAULT;
 
@@ -1143,6 +1203,9 @@
 {
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|olduname");
+
 	if (!name)
 		return -EFAULT;
 	if (!access_ok(VERIFY_WRITE, name, sizeof(struct oldold_utsname)))
@@ -1177,6 +1240,9 @@
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sethostname");
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1226,6 +1292,10 @@
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setdomainname");
+
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1249,6 +1319,9 @@
 	struct rlimit value;
 	int ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getrlimit");
+
 	ret = do_prlimit(current, resource, NULL, &value);
 	if (!ret)
 		ret = copy_to_user(rlim, &value, sizeof(*rlim)) ? -EFAULT : 0;
@@ -1445,6 +1518,9 @@
 {
 	struct rlimit new_rlim;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setrlimit");
+
 	if (copy_from_user(&new_rlim, rlim, sizeof(*rlim)))
 		return -EFAULT;
 	return do_prlimit(current, resource, &new_rlim, NULL);
@@ -1576,6 +1652,9 @@
 
 SYSCALL_DEFINE2(getrusage, int, who, struct rusage __user *, ru)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getrusage");
+
 	if (who != RUSAGE_SELF && who != RUSAGE_CHILDREN &&
 	    who != RUSAGE_THREAD)
 		return -EINVAL;
@@ -1584,6 +1663,9 @@
 
 SYSCALL_DEFINE1(umask, int, mask)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|umask");
+
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
 	return mask;
 }
@@ -1595,6 +1677,9 @@
 	unsigned char comm[sizeof(me->comm)];
 	long error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|prctl");
+
 	error = security_task_prctl(option, arg2, arg3, arg4, arg5);
 	if (error != -ENOSYS)
 		return error;
@@ -1748,6 +1833,9 @@
 {
 	int err = 0;
 	int cpu = raw_smp_processor_id();
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getcpu");
+
 	if (cpup)
 		err |= put_user(cpu, cpup);
 	if (nodep)
diff -Naur linux-source-2.6.38.orig/kernel/sysctl_binary.c linux-source-2.6.38.modif/kernel/sysctl_binary.c
--- linux-source-2.6.38.orig/kernel/sysctl_binary.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/sysctl_binary.c	2011-12-16 15:41:44.000000000 +0100
@@ -1464,6 +1464,9 @@
 	size_t oldlen = 0;
 	ssize_t result;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|sysctl");
+
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
 
